#pragma once

#include <vector>
#include <string>
#include <cstddef>

namespace massivedynamic {
	
class Renderer {
	protected:
		const std::vector<bool>& pixels;
		size_t sourceSize;
		size_t targetSize;
	public:
		Renderer(const std::vector<bool>& pixels, size_t sourceSize, size_t targetSize) : pixels(pixels), sourceSize(sourceSize), targetSize(targetSize) {}
		Renderer(const Renderer&&)           = delete;
		Renderer(Renderer&)                  = delete;
		virtual ~Renderer()                  = default;
		Renderer& operator=(const Renderer&) = delete;

		virtual void render(const std::string& filename) = 0;
};

}
